<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.cache.CacheFetcher</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        <a href="pyxmpp.cache-module.html">Module&nbsp;cache</a> ::
        Class&nbsp;CacheFetcher
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<!-- ==================== CLASS DESCRIPTION ==================== -->
<h1 class="epydoc">Class CacheFetcher</h1><p class="nomargin-top"><span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher">source&nbsp;code</a></span></p>
<dl><dt>Known Subclasses:</dt>
<dd>
      <ul class="subclass-list">
<li><a href="pyxmpp.jabber.disco.DiscoCacheFetcherBase-class.html">jabber.disco.DiscoCacheFetcherBase</a></li>  </ul>
</dd></dl>

<hr />
<p>Base class for cache object fetchers -- classes responsible for
retrieving objects from network.</p>
<p>An instance of a fetcher class is created for each object requested and
not found in the cache, then <a href="pyxmpp.cache.CacheFetcher-class.html#fetch" class="link">fetch</a> method is called to initialize
the asynchronous retrieval process. Fetcher object's <a href="pyxmpp.cache.CacheFetcher-class.html#got_it" class="link">got_it</a> method
should be called on a successfull retrieval and <a href="pyxmpp.cache.CacheFetcher-class.html#error" class="link">error</a> otherwise.
<a href="pyxmpp.cache.CacheFetcher-class.html#timeout" class="link">timeout</a> will be called when the request timeouts.</p>

<!-- ==================== INSTANCE METHODS ==================== -->
<a name="section-InstanceMethods"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Instance Methods</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-InstanceMethods"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.cache.CacheFetcher-class.html#__init__" class="summary-sig-name">__init__</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">cache</span>,
        <span class="summary-sig-arg">address</span>,
        <span class="summary-sig-arg">item_freshness_period</span>,
        <span class="summary-sig-arg">item_expiration_period</span>,
        <span class="summary-sig-arg">item_purge_period</span>,
        <span class="summary-sig-arg">object_handler</span>,
        <span class="summary-sig-arg">error_handler</span>,
        <span class="summary-sig-arg">timeout_handler</span>,
        <span class="summary-sig-arg">timeout_period</span>,
        <span class="summary-sig-arg">backup_state</span>=<span class="summary-sig-default">None</span>)</span><br />
      Initialize an <a href="pyxmpp.cache.CacheFetcher-class.html" class="link">CacheFetcher</a> object.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher.__init__">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_deactivate"></a><span class="summary-sig-name">_deactivate</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Remove the fetcher from cache and mark it not active.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher._deactivate">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_deactivated"></a><span class="summary-sig-name">_deactivated</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Mark the fetcher inactive after it is removed from the cache.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher._deactivated">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">bool</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.cache.CacheFetcher-class.html#_try_backup_item" class="summary-sig-name" onclick="show_private();">_try_backup_item</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Check if a backup item is available in cache and call
the item handler if it is.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher._try_backup_item">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.cache.CacheFetcher-class.html#error" class="summary-sig-name">error</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">error_data</span>)</span><br />
      Handle a retrieval error and call apriopriate handler.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher.error">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.cache.CacheFetcher-class.html#fetch" class="summary-sig-name">fetch</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Start the retrieval process.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher.fetch">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.cache.CacheFetcher-class.html#got_it" class="summary-sig-name">got_it</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">value</span>,
        <span class="summary-sig-arg">state</span>=<span class="summary-sig-default"><code class="variable-quote">'</code><code class="variable-string">new</code><code class="variable-quote">'</code></span>)</span><br />
      Handle a successfull retrieval and call apriopriate handler.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher.got_it">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.cache.CacheFetcher-class.html#timeout" class="summary-sig-name">timeout</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Handle fetcher timeout and call apriopriate handler.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher.timeout">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
</table>
<!-- ==================== INSTANCE VARIABLES ==================== -->
<a name="section-InstanceVariables"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Instance Variables</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-InstanceVariables"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: <code class="link">bool</code></span>
    </td><td class="summary">
        <a name="active"></a><span class="summary-name">active</span><br />
      : <code class="link">True</code> as long as the fetcher is active and requestor
expects one of the handlers to be called.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: any hashable</span>
    </td><td class="summary">
        <a name="address"></a><span class="summary-name">address</span><br />
      : requested item address.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: <a href="pyxmpp.cache.Cache-class.html" class="link">Cache</a></span>
    </td><td class="summary">
        <a name="cache"></a><span class="summary-name">cache</span><br />
      : cache object which created this fetcher.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: datetime</span>
    </td><td class="summary">
        <a name="timeout_time"></a><span class="summary-name">timeout_time</span><br />
      : timeout time.
    </td>
  </tr>
</table>
<!-- ==================== METHOD DETAILS ==================== -->
<a name="section-MethodDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Method Details</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-MethodDetails"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
</table>
<a name="__init__"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">__init__</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">cache</span>,
        <span class="sig-arg">address</span>,
        <span class="sig-arg">item_freshness_period</span>,
        <span class="sig-arg">item_expiration_period</span>,
        <span class="sig-arg">item_purge_period</span>,
        <span class="sig-arg">object_handler</span>,
        <span class="sig-arg">error_handler</span>,
        <span class="sig-arg">timeout_handler</span>,
        <span class="sig-arg">timeout_period</span>,
        <span class="sig-arg">backup_state</span>=<span class="sig-default">None</span>)</span>
    <br /><em class="fname">(Constructor)</em>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher.__init__">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Initialize an <a href="pyxmpp.cache.CacheFetcher-class.html" class="link">CacheFetcher</a> object.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>cache</code></strong> (: <a href="pyxmpp.cache.Cache-class.html" class="link">Cache</a>) - : cache object which created this fetcher.</li>
        <li><strong class="pname"><code>address</code></strong> (: any hashable) - : requested item address.</li>
        <li><strong class="pname"><code>item_freshness_period</code></strong> (: timedelta) - : freshness period for the requested item.</li>
        <li><strong class="pname"><code>item_expiration_period</code></strong> (: timedelta) - : expiration period for the requested item.</li>
        <li><strong class="pname"><code>item_purge_period</code></strong> (: timedelta) - : purge period for the requested item.</li>
        <li><strong class="pname"><code>object_handler</code></strong> (: callable(address, value, state)) - : function to be called after the item is fetched.</li>
        <li><strong class="pname"><code>error_handler</code></strong> (: callable(address, error_data)) - : function to be called on error.</li>
        <li><strong class="pname"><code>timeout_handler</code></strong> (: callable(address)) - : function to be called on timeout</li>
        <li><strong class="pname"><code>timeout_period</code></strong> (: timedelta) - : timeout interval.</li>
        <li><strong class="pname"><code>backup_state</code></strong> (: <code class="link">bool</code>) - : when not <code class="link">None</code> and the fetch fails than an
object from cache of at least this state will be passed to the
<code class="link">object_handler</code>. If such object is not available, then
<code class="link">error_handler</code> is called.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="_try_backup_item"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_try_backup_item</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher._try_backup_item">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Check if a backup item is available in cache and call
the item handler if it is.
  <dl class="fields">
    <dt>Returns: <code class="link">bool</code></dt>
        <dd><code class="link">True</code> if backup item was found.</dd>
  </dl>
</td></tr></table>
</div>
<a name="error"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">error</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">error_data</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher.error">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Handle a retrieval error and call apriopriate handler.</p>
<p>Should be called when retrieval fails.</p>
<p>Do nothing when the fetcher is not active any more (after
one of handlers was already called).</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>error_data</code></strong> (: fetcher dependant) - : additional information about the error (e.g. <code class="link">StanzaError</code> instance).</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="fetch"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">fetch</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher.fetch">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Start the retrieval process.</p>
<p>This method must be implemented in any fetcher class.</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<a name="got_it"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">got_it</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">value</span>,
        <span class="sig-arg">state</span>=<span class="sig-default"><code class="variable-quote">'</code><code class="variable-string">new</code><code class="variable-quote">'</code></span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher.got_it">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Handle a successfull retrieval and call apriopriate handler.</p>
<p>Should be called when retrieval succeeds.</p>
<p>Do nothing when the fetcher is not active any more (after
one of handlers was already called).</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>value</code></strong> (: any) - : fetched object.</li>
        <li><strong class="pname"><code>state</code></strong> (: <code class="link">str</code>) - : initial state of the object.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="timeout"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">timeout</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.cache-pysrc.html#CacheFetcher.timeout">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Handle fetcher timeout and call apriopriate handler.</p>
<p>Is called by the cache object and should _not_ be called by fetcher or
application.</p>
<p>Do nothing when the fetcher is not active any more (after
one of handlers was already called).</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:34:58 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
